Library LsSlider;

Uses vc_engine,windows;

Const
  lsapi='lsapi.dll';
  WM_PAINT = $000F;
  WM_ERASEBKGND = $0014;
  WM_MOUSEMOVE = $0200;
  WM_LBUTTONDOWN = $0201;
  WM_LBUTTONUP = $0202;
  WM_RBUTTONUP = $0205;
  WM_RBUTTONDOWN = $0204;
  WM_MOUSELEAVE = $02A3;
  WM_USER = $0400;
  WM_TIMER = $0113;
  WM_UPDATE = WM_USER + 98;
  WM_CHANGE = WM_USER + 99;
  TTS_ALWAYSTIP = $01;
  TTF_SUBCLASS = $0010;
  TTM_DELTOOL = WM_USER + 5;
  TRACKSET =  WM_USER + 13 ;
  TRACKGET =  WM_USER + 14 ;
  TRACKLENGTH = WM_USER + 17;
  PLAYING = WM_USER + 10;
  PAUSED = WM_USER + 11;




Type
  TType = (Horizontal, Vertical);
  TMode = (none, Volume, Balance, foobar, Bangs);
  //Toolinfo declaration for tooltips
  PToolInfo = ^TToolInfo;
  TToolInfo = packed record
                cbSize: UINT;
                uFlags: UINT;
                hwnd: HWND;
                uId: UINT;
                Rect: TRect;
                hInst: THandle;
                lpszText: PAnsiChar;
              end;

  PSlider = ^TSlider;
  TSlider = Record
              Typ: TType;
              Mode: TMode;
              Inverted,
              Moveable,
              Visible: Boolean;
              hMainWnd, //Main window handle
              ClientWnd: HWND; //Client (handle) window handle
              Timer: Integer; //Timer Handle
              BackDC,   //Background Memory Device Context
              HandDC: HDC;  //Handle Memory Device Context
              hxPos, hyPos, hoffs, hHeight, hWidth,
              ch, xPos, yPos,Height, Width: Integer;
              GroupID: Integer;
              Next_Slider: Pointer;
            End;

Var
  First_Slider: Pointer = nil;
  hwndfoobar: HWND = 0;
  Hint_HWND: HWND = 0;



//Litestep Functions
Function LCOpen(szPath: PChar): Integer; cdecl; external lsapi;
Function LCReadNextConfig(F: integer; szPrefix,szBuffer : Pchar; dwLength: integer): Boolean; cdecl; external lsapi;
Function LCClose(F: integer): Boolean; cdecl; external lsapi;
Function LSExecute(Owner: Integer;szCommand: PChar;nShowCmd: Boolean): Integer; cdecl; external lsapi;
Function LoadLSImage (szImage, szFile: PChar): HBitmap; cdecl; external lsapi;
function GetRCBool(lpKeyName: string;ifFound:BOOLEAN): Boolean; cdecl; external lsapi;
function AddBangCommand(command: string; f: Pointer): Boolean; cdecl; external lsapi;
function RemoveBangCommand(command: string): Boolean; cdecl; external lsapi;
Procedure GetLSBitmapSize(hBitmap: Integer;Var x, y: Integer); cdecl; external lsapi;
Function BitmapToRegion (hBmp: Integer;cTransparentColor, cTolerance: Integer;xoffset, yoffset: Integer): HRGN; cdecl; external lsapi;


procedure InitCommonControls; stdcall; external 'comctl32.dll';

Function StrAlloc(Size: Cardinal): PChar;
begin
  Inc(Size, SizeOf(Cardinal));
  GetMem(Result, Size);
  Cardinal(Pointer(Result)^) := Size;
  Inc(Result, SizeOf(Cardinal));
end;

Procedure StrDispose(Str: PChar);
begin
  if Str <> nil then
  begin
    Dec(Str, SizeOf(Cardinal));
    FreeMem(Str, Cardinal(Pointer(Str)^));
  end;
end;



function Int4Str(Number : Int64) : String;
var Minus : Boolean;
begin
{SysUtils is not in the Uses Clause so I can not use IntToStr( )
and have to define an Int2Str( ) function here}
   Result := '';
   if Number = 0 then
      Result := '0';
   Minus := Number < 0;
   if Minus then
      Number := -Number;
   while Number > 0 do
   begin
      Result := Char((Number mod 10) + Integer('0')) + Result;
      Number := Number div 10;
   end;
   if Minus then
      Result := '-' + Result;
end;

function Int2Chr(i: Integer): Char;
begin
  if i < 10 then Result := Char(i + Integer('0')) else
  Result := Char(i - 10 + Integer('A'));
end;

function Int2Str(v: Integer; base: Integer): String;
var
  m: Integer;
begin
  Result := '';
  while v <> 0 do begin
    m := v mod base; v := v div base; Result := Int2Chr(m) + Result;
  end;
  if Result = '' then Result := '0';
end;

Function Str2Int(s: String): Integer;
Var
  i,c,v : integer;

Function Pot(b,e: integer):LongInt;
Begin
  If (e=0) then
    Pot := 1
  Else
    Pot := b * Pot(b,e-1);
End;

Begin
  c := 0;v := 1;
  For i := length(s)-1 downto 0 do
    If ( s[i+1]='-' ) Then
      v := -1
    Else
      c := c + ( (ord(s[i+1])-48)*Pot(10,length(s)-i-1) );
  Str2Int := c*v;
End;

Function Tokenize(Args: String;n: Byte): String;
Var
  a,e,i: Integer;
  c: Char;
Begin
  e:=1;C := #32;a:=0;
  For i:=1 to N do
  Begin
    If (c=#34) then inc(e);
    c := #32;
    While (Args[e]=c)DO Inc(e);
    If (Args[e]=#34) then Begin
      c := #34;inc(e);end;
    a:=e;
    While Not((Args[e]=c)OR(Args[e]=#0))DO Inc(e);
  End;
  If a<>e then
    Result := Copy(Args,a,e-a)
  else
    Result := '';
End;

Function CheckFlag(Flags:String; Flag:Char):byte;
Var
  i: integer;
Begin
  Result := 0;
  For i:= 1 to Length(Flags) do
    If ( UpCase(Flags[i])=Flag ) Then
      Result := i;
End;

Function GetGroup(Flags: String): Integer;
Var
  b,e: integer;
Begin
  b := CheckFlag(Flags,'#');
  If Boolean(b) then
  Begin
    e := b+1;
    While (e<Length(Flags))AND(Flags[e+1]<':')AND(Flags[e+1]>'/') do Inc(e);
    Result := Str2Int( Copy(Flags,b+1,e-1) );
  End Else
    Result := 0;
End;

Procedure CreateHint(Wnd: Hwnd;Txt: Pchar);
Const
  TTM_ADDTOOL = WM_USER + 4;
Var
  Ti: TToolInfo;
Begin
  If Hint_HWND=0 Then
  Begin
    InitCommonControls;
    Hint_HWND := CreateWindowEx(0,
       'Tooltips_class32', nil, TTS_ALWAYSTIP,
       CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
       CW_USEDEFAULT, 0, 0, hinstance, nil);
    If Hint_HWND=0 then
      MessageboxA(0,'Error Creating Tooltip Control',nil,0);
    SetWindowPos(Hint_HWND,HWND_TOPMOST,CW_USEDEFAULT,
      CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,SWP_NOMOVE+SWP_NOSIZE+SWP_NOACTIVATE);
  end;
  Ti.cbSize := SizeOf(TToolInfo);
  Ti.uFlags := TTF_SUBCLASS;
  Ti.hInst := hInstance;
  Ti.hwnd := wnd;
  Ti.uId := 0;
  GetClientRect(Wnd, Ti.rect);
  Ti.lpszText := txt;
  SendMessage(Hint_HWND,TTM_ADDTOOL,0,Integer(@Ti))
End;

Procedure RemoveHint(Wnd: HWND);
Var
  Ti: TToolInfo;
Begin
  ti.cbSize := sizeof(TTOOLINFO);
  ti.uFlags := 0;
  ti.hwnd := Wnd;
  ti.hinst := hInstance;
  ti.uId := 0;
  ti.lpszText := Nil;
  PostMessage(Hint_HWND,TTM_DELTOOL,0,Integer(@Ti));
End;

Function GetSliderFromWnd(Slider: PSlider; Wnd: Integer): PSlider;
Begin
  If (Slider^.Next_Slider = nil) OR (Slider^.hMainWnd = Wnd) then
    Result := Slider
  Else
    Result := GetSliderFromWnd(Slider^.Next_Slider, Wnd);
End;

function WndProc(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
Var
  Slider : PSlider;
  P : TPoint;
  Left, Right, tmp, ret, tmp1: Integer;
  length, change, pos: Extended;
Begin
  WndProc := 0;tmp := 0;
  Slider := GetSliderFromWnd(First_Slider,Wnd);
  hwndfoobar := findwindow ('frw_cls',nil);
    Case Msg Of
      WM_ERASEBKGND:
        BitBlt(wParam,0,0,Slider^.Width,Slider^.Height,Slider^.BackDc,0,0,SRCCOPY);
      WM_CHANGE:
        Begin
          Case Slider^.Mode Of
            Volume:
              Begin
                Change_Volume(Slider^.ch,wParam);
              End;
            Balance:
              Begin
                Change_Balance(Slider^.ch,((100-wParam)*2)-100);
              End;
            foobar:
              Begin
              PostMessage(hwndfoobar,TRACKSET, 1, Round (  (Wparam/100) * SendMessage(hwndfoobar,TRACKLENGTH, 0, 0) ));
              End;
          End;
        End;
      WM_UPDATE:
        With Slider^ do
        Begin
          Case Slider^.Mode Of
            Volume:
              Begin
                GetVolumeA(ch,Left,Right);
                If (Right>Left) Then
                  Tmp := 100-(Right DIV 655)
                Else
                  Tmp := 100-(Left DIV 655);
              End;
            Balance:
              Begin
                GetVolumeA(ch,left,right);
                If ( Right>Left ) Then
                  Tmp := 100-(Left DIV (Right DIV 100))
                Else
                  Tmp := -100+(Right DIV (Left DIV 100));
                Tmp := (Tmp+100)DIV 2;
              End;
            foobar:
              Begin
                hwndfoobar := findwindow ('frw_cls',nil);
                If (hwndfoobar <> 0)Then
                 Begin                        
                 if SendMessage(hwndfoobar,PAUSED, 0, 0) OR SendMessage(hwndfoobar,PLAYING, 0, 0) = 1 Then
                 //PLAY OR PAUSED.. s
                   Begin
                       ShowWindow(ClientWnd,SW_SHOW);
                       Tmp1 := (SendMessage(hwndfoobar,TRACKGET,0,0)) DIV (Tmp) * 100;
                       Tmp := Tmp1;
                   End Else
                       ShowWindow(ClientWnd,SW_HIDE);
               End Else
               ShowWindow(ClientWnd,SW_HIDE);
              End;
          End;

        If (Inverted) Then
          Tmp := 100-Tmp;
        If ( Typ=Vertical ) then
          hyPos := Round(((Height-2*hoffs-hHeight)/100)*Tmp)+hoffs
        Else
          hxPos := Round(((Width-2*hoffs-hWidth)/100)*Tmp)+hoffs;
        SetWindowPos(ClientWnd,0,hxPos,hyPos,0,0,SWP_NOSIZE+SWP_NOZORDER);
      End;
    WM_TIMER:
      PostMessage(Slider^.hMainwnd,WM_UPDATE,0,0);

    WM_MOUSEMOVE:
      If ( Slider^.Moveable AND ( wParam = MK_RBUTTON ))Then
        Begin
          GetCursorPos(P);
          Slider^.xPos := P.X-Slider^.Width DIV 4;
          Slider^.yPos := P.Y-Slider^.Height DIV 4;
          SetWindowPos(Wnd,0,Slider^.xPos,Slider^.yPos,0,0,SWP_NOSIZE+SWP_NOZORDER);
        End;
    WM_LBUTTONDOWN:
      Begin
        SetCapture(Slider^.Clientwnd);
        PostMessage(Slider^.Clientwnd,WM_MOUSEMOVE,MK_LBUTTON,0);
      End;
    WM_RBUTTONDOWN:
      If ( Slider^.Moveable ) Then
        Begin
          SetCapture(wnd);
          PostMessage(Slider^.hMainwnd,WM_MOUSEMOVE,MK_RBUTTON,0);
        End;
    WM_RBUTTONUP:
      If ( Slider^.Moveable ) Then
        ReleaseCapture;
      Else
        WndProc := DefWindowProc(Wnd,msg,wParam,lParam);
    End;
End;

Function GetSliderFromClient(Slider: PSlider;Wnd: Integer): PSlider;
Begin
  Result := GetSliderFromWnd(Slider, GetParent(Wnd));
End;

function ClientWndProc(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
Var
  ps : TPaintStruct;
  fdc : HDC;
  Slider : PSlider;
  P : TPoint;
  Value : Integer;
Begin
  ClientWndProc := 0;
  Slider := GetSliderFromClient(First_Slider,Wnd);
    Case Msg Of
      WM_PAINT:
          Begin
            fdc := BeginPaint(Wnd,ps);
              BitBlt(fdc,0,0,Slider^.hWidth,Slider^.hHeight,Slider^.HandDc,0,0,SRCCOPY);
            EndPaint(Wnd,ps);
          End;
      WM_MOUSEMOVE:
        If ( wParam = MK_LBUTTON ) Then
          With Slider^ do
          Begin
            GetCursorPos(P);
            If ( Typ=Vertical ) then
              Begin
                hyPos := (P.Y - yPos)-(hHeight DIV 2);
                If (hypos < hoffs) then
                  hypos := hoffs
                  Else
                    If (hypos > ((Height-hHeight)-hoffs)) then
                      hypos := (Height-hHeight)-hoffs;
                Value := Round((hyPos-hoffs)/((Height-2*hoffs-hHeight)/100));
              End
            Else
              Begin
                hxPos := (P.X - xPos)-(hWidth DIV 2);
                If (hxpos < hoffs) then
                  hxpos := hoffs
                  Else
                    If (hxpos > ((Width-hWidth)-hoffs)) then
                      hxpos := (Width-hWidth)-hoffs;
                Value := Round((hxPos-hoffs)/((Width-2*hoffs-hWidth)/100));
              End;

            If NOT(Inverted) Then
              Value := 100-Value;
              
            SetWindowPos(Wnd,0,hxPos,hyPos,0,0,SWP_NOSIZE+SWP_NOZORDER);
            PostMessage(hMainWnd,WM_CHANGE,Value,0);
          End;
      WM_LBUTTONDOWN:
        SetCapture(wnd);
      WM_LBUTTONUP:
        ReleaseCapture;
      Else
        ClientWndProc := DefWindowProc(Wnd,msg,wParam,lParam);
    End;
End;

Procedure Build_Sliders(ParentWnd:Integer; dllInst:LongInt);
Var
  Rc: Integer;
  wc: TWndClass;
  Buffer: PChar;
  BackGround, Handle: Integer;
  Slider: PSlider;
  Caption, Md, Flags: String;
Begin
  Buffer := StrAlloc(256);
  Rc:=LCOpen(nil);
  While LCReadNextConfig(Rc,'*Slider',buffer,255) Do
    Begin
      New (Slider);
      Slider^.Next_Slider := First_Slider;
      First_Slider := Slider;

      Caption := Tokenize (Buffer,2);
      Slider^.xPos := Str2Int (Tokenize (Buffer,3));
      If (Slider^.xPos<0) then
        Slider^.xPos := GetSystemMetrics(SM_CXSCREEN) + Slider^.xPos;
      Slider^.yPos := Str2Int (Tokenize (Buffer,4));
      If (Slider^.yPos<0) then
        Slider^.yPos := GetSystemMetrics(SM_CYSCREEN) + Slider^.yPos;
      Slider^.hoffs := Str2Int (Tokenize (Buffer,5));
      Background := LoadLSImage(PChar(Tokenize (Buffer,6)),nil);
      handle := LoadLSImage(PChar(Tokenize (Buffer,7)),nil);
      
      If (Background=0)OR(Handle=0) then
      Begin
        Messagebox(0,PChar('Check Step.Rc:'+#13+Tokenize (Buffer,6)+
          #13+'or'+#13+Tokenize (Buffer,7)),'Can''t load image',0);
        DeleteObject(BackGround);
        First_Slider := Slider^.Next_Slider;
        Dispose(Slider);Exit;
      End;

      Flags := Tokenize (Buffer,8);

      Slider^.Moveable := Boolean(CheckFlag(Flags,'M'));
      Slider^.Inverted := Boolean(CheckFlag(Flags,'I'));
      Slider^.Visible := true;
      Slider^.GroupID := GetGroup(Flags);

      If ( Boolean(CheckFlag(Flags,'H')) ) Then
        Slider^.Typ := Horizontal
      Else
        Slider^.Typ := Vertical;

      Slider^.Mode := none;
      Md := Tokenize (Buffer,9);
      If ( Md= '[VOLUME]' ) Then
        Begin
          Slider^.Mode := Volume;
          Slider^.ch := Str2Int (Tokenize (Buffer,10));
        End
        Else
        If ( Md= '[BALANCE]' )Then
          Begin
            Slider^.Mode := Balance;
            Slider^.ch := Str2Int (Tokenize (Buffer,10));
          End
          Else
          If ( Md= '[FOOBAR]' )Then
            Slider^.Mode := foobar
            Else
            If ( Md= '[BANG]' )Then
              Messageboxa(0,'This Slidermode is currenly non-functional','Slidermode [BANGS]',0);

      GetLSBitmapSize(Background,Slider^.Width,Slider^.Height);
      GetLSBitmapSize(Handle,Slider^.hWidth,Slider^.hHeight);

      Slider^.hxPos := (Slider^.Width-Slider^.hWidth) DIV 2;
      Slider^.hyPos := (Slider^.Height-Slider^.hHeight) DIV 2;

      If NOT GetClassInfo(hInstance,'LsSliderClass',wc) then
      Begin
        FillChar(wc,sizeof(wc), #0);
        wc.lpfnWndProc := @WndProc;
        wc.lpszClassName := 'LsSliderClass';
        wc.hInstance := hinstance;
        RegisterClassA(wc);
      End;

      If NOT GetClassInfo(hInstance,'LsSliderHandle',wc) then
      Begin
        FillChar(wc,sizeof(wc), #0);
        wc.lpfnWndProc := @ClientWndProc;
        wc.lpszClassName := 'LsSliderHandle';
        wc.hInstance := hinstance;
        RegisterClassA(wc);
      End;

      With Slider^ Do
      Begin
        hMainWnd := CreateWindowExA(
          0,'LsSliderClass',PChar(Caption),WS_POPUP,
          0,0,0,0,{ParentWnd}0,0,
          hinstance,nil);

        If Boolean(CheckFlag(Flags,'A')) then
          SetWindowPos(hMainWnd, 0, xPos, yPos, Width, Height, $40)
        Else
          Begin
            SetParent( hMainWnd,  FindWindow('DesktopBackgroundClass', nil));
            SetWindowPos(hMainWnd, 0, xPos, yPos, Width, Height, $40);
          End;
          
        SetWindowLong(hMainWnd,GWL_USERDATA,$49474541);
        CreateHint(hMainWnd,PChar(Caption));
        
        ClientWnd := CreateWindowExA(
          0,'LsSliderHandle',nil,WS_CHILD,
          0,0,0,0,hMainWnd,0,
          hinstance,nil);
        SetWindowPos(ClientWnd, 0, hxPos, hyPos, hWidth, hHeight, $40);

        If ( Slider^.Mode=none ) Then
        Begin
          ShowWindow(ClientWnd,SW_HIDE);
          Messageboxa(0,'Slider Mode not recognized - Check Spelling',nil,0);
        End;

        If ( Boolean(CheckFlag(Flags,'U')) )OR( Mode=foobar ) Then
          Timer := SetTimer(hMainWnd,0,250,nil);

        If Boolean(CheckFlag(Flags,'T')) Then
        Begin
          SetWindowRgn(hMainWnd,BitmapToRegion(Background,RGB(255,0,255),$101010,0,0),True);
          SetWindowRgn(ClientWnd,BitmapToRegion(Handle,RGB(255,0,255),$101010,0,0),True);
        End;

        BackDC := CreateCompatibleDC(GetDC(Slider^.hMainWnd));
        HandDC := CreateCompatibleDC(GetDC(Slider^.ClientWnd));
        SelectObject(BackDc, Background);
        SelectObject(HandDc, Handle);
        DeleteObject(BackGround);
        DeleteObject(Handle);

        InvalidateRgn(hMainWnd,0,true);
        PostMessage(hMainWnd,WM_UPDATE,0,0);
      End;
    End;

  If NoT(LCClose(rc)) then
    MessageboxA(0,'Error Closing RC','',0);
  StrDispose(Buffer);
End;

Procedure toggle_slider(Caller:Integer;Args:pchar); cdecl;
Var
  group: Integer;
  Slider: PSlider;
Begin
  Group := Str2Int(Args);
  Slider := First_Slider;
  While ( Slider<>nil ) Do
  Begin
    If ( Slider^.groupID=Group) Then
    Begin
      If Slider^.visible then
        ShowWindow(Slider^.hMainWnd,SW_HIDE)
      Else
       ShowWindow(Slider^.hMainWnd,SW_SHOW);
      Slider^.Visible := NOT(Slider^.Visible)
    End;
    Slider := Slider^.Next_Slider;
  End;
End;

Procedure hide_slider(Caller:Integer;Args:pchar); cdecl;
Var
  group: Integer;
  Slider: PSlider;
Begin
  Group := Str2Int(Args);
  Slider := First_Slider;
  While ( Slider<>nil ) Do
  Begin
    If ( Slider^.groupID=Group) Then
      ShowWindow(Slider^.hMainWnd,SW_HIDE);
    Slider := Slider^.Next_Slider;
  End;
End;

Procedure show_slider(Caller:Integer;Args:pchar); cdecl;
Var
  group: Integer;
  Slider: PSlider;
Begin
  Group := Str2Int(Args);
  Slider := First_Slider;
  While ( Slider<>nil ) Do
  Begin
    If ( Slider^.groupID=Group) Then
      ShowWindow(Slider^.hMainWnd,SW_HIDE);
    Slider := Slider^.Next_Slider;
  End;
End;

Function initModuleEx(ParentWnd:Integer;dllInst:Longint;szPath:PCHAR):longint; cdecl;
Begin
  Init(0);
  AddBangCommand('!ToggleSliderGroup',@toggle_slider);
  AddBangCommand('!HideSliderGroup',@Hide_slider);
  AddBangCommand('!ShowSliderGroup',@Hide_slider);

  Build_Sliders(ParentWnd, dllInst);
  initModuleEx := 0
End;
                                      
Procedure quitModule(dllInst : Longint); cdecl;
Var
  wc: TWndClass;
  Slider: PSlider;
Begin
  RemoveBangCommand('!ToggleSliderGroup');
  RemoveBangCommand('!HideSliderGroup');
  RemoveBangCommand('!ShowSliderGroup');
  Slider := First_Slider;
  While ( Slider<>nil ) Do
  Begin
    DeleteDC(Slider^.BackDC);
    DeleteDC(Slider^.HandDC);
    KillTimer(Slider^.hMainWnd,Slider^.Timer);
    RemoveHint(Slider^.hMainWnd);
    DestroyWindow(Slider^.hMainWnd);
    First_Slider := Slider^.Next_Slider;
    Dispose (Slider);
    Slider := First_Slider;
  End;
  Destroywindow(Hint_HWND);
  If GetClassInfo(hInstance,'LsSliderClass',wc) then
    UnregisterClass('LsSliderClass',hinstance);
  Destroy;
End;

Exports
  initModuleEx Index 1,
  quitModule index   2;

End.